<?php
/**
 * @package     Joomla.Plugin
 * @subpackage  System.Jblibrary
 * @author      Joomla Bamboo - design@joomlabamboo.com
 * @copyright   Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @version     2.1.5-beta3
 */
defined('_JEXEC') or die ;

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class plgSystemJblibraryInstallerScript
{
	public function postflight($route, $adapter)
	{
		$success = true;
		$uninstall = false;

		echo '<div><h2>Last install step:</h2>Please visit the JB library <a href="index.php?option=com_plugins&amp;view=plugins">plugin settings page</a> and update your plugin settings. This version includes some updates and improvements that need to be applied via the settings panel. Please edit the plugin and hit apply to save the new settings.</div>';

		// Uninstall the old library Zen Library
		$path = JPATH_ROOT . '/media/zen';
		if (JFolder::exists($path))
		{
			$uninstall = true;

			if (! JFolder::delete($path))
			{
				$success = false;
			}
 		}

 		$path = JPATH_ROOT . '/libraries/zen';
		if (JFolder::exists($path))
		{
			$uninstall = true;

			if (! JFolder::delete($path))
			{
				$success = false;
			}
 		}

 		$path = JPATH_ROOT . '/administrator/manifests/libraries/zen.xml';
		if (JFile::exists($path))
		{
			$uninstall = true;

			if (! JFile::delete($path))
			{
				$success = false;
			}
		}

		$path = JPATH_ROOT . '/administrator/manifests/packages/pkg_jblibrary_zenlibrary.xml';
		if (JFile::exists($path))
		{
			$uninstall = true;

			if (! JFile::delete($path))
			{
				$success = false;
			}
		}

		$db = JFactory::getDbo();
		$query = 'DELETE FROM #__extensions WHERE element LIKE "pkg_jblibrary_zenlibrary" OR element LIKE "zen"';
		$db->setQuery($query);
		$db->execute();


 		if ($uninstall)
 		{
	 		if ($success)
	 		{
	 			?>
				<div style="color: green">
					Old zen Library uninstalled succesfully.
				</div>
				<?php
	 		}
	 		else
	 		{
	 			?>
				<div style="color: red">
					Error uninstalling the Zen Library library. You should remove it manually.
				</div>
				<?php
	 		}
 		}

		return $success;
	}
}
